//+------------------------------------------------------------------+
//|                                                        Aroon.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_maximum 1
#property indicator_minimum 0
#property indicator_width1  2
#property indicator_width2  2

extern int AroonPeriod=25;

//
//
//
//
//

double buffer1[];
double buffer2[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
   IndicatorShortName("Aroon ("+AroonPeriod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=Bars-counted_bars;
  
   for(int i=limit; i>=0; i--)
   {
      double ah = 100.0*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod+1,i)+i)/AroonPeriod;
      double al = 100.0*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod+1,i)+i)/AroonPeriod;
         buffer1[i] = EMPTY_VALUE;
         buffer2[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1];
            if (ah>al) trend[i] =  1;
            if (ah<al) trend[i] = -1;
            if (trend[i] ==  1) buffer1[i] = 1;
            if (trend[i] == -1) buffer2[i] = 1;
   }
   return(0);
}